package xyz.lychee.lagfixer.libs.adventure.text.minimessage;

import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.annotations.ApiStatus.NonExtendable;

@NonExtendable
public abstract class ParsingException extends RuntimeException {
   private static final long serialVersionUID = 4502774670340827070L;
   public static final int LOCATION_UNKNOWN = -1;

   protected ParsingException(final @Nullable String message) {
      super(message);
   }

   protected ParsingException(final @Nullable String message, final @Nullable Throwable cause) {
      super(message, cause);
   }

   protected ParsingException(final String message, final Throwable cause, final boolean enableSuppression, final boolean writableStackTrace) {
      super(message, cause, enableSuppression, writableStackTrace);
   }

   public abstract @NotNull String originalText();

   public abstract @Nullable String detailMessage();

   public abstract int startIndex();

   public abstract int endIndex();
}
